<?php
/*
OekakiPoteto 5.x Copyright 2000-2002 RanmaGuy (Theo Chakkapark, http://suteki.nu) and Marcello Basta-Forte (http://marcello.cellosoft.com). Modification to the files are permitted as long as my name remains on the files.

Wax Poteto modifications Copyright Marc "Waccoon" Leveille
http://www.NineChime.com/products/
Version 5.8.2 - Last modified 12/26/2010
*/


/*
NOTES:
	Cookies are sent as the HTTP GET method, and thus don't [aren't supposed to] work with POST.  However, since OekakiBBS doesn't support header data, we have to mimick cookies by spoofing POST data as GET.  This is the technique Wacintaki used to use with PaintBBS and ShiPainter before v1.3, and has since been obsoleted.  Expect some major differences between the code used for this applet and the others, and some variables normally required for the other paint programs may not be used here.

	if (new pic) {
		Send nothing to comment.php.
	} elseif (public edit by new artist) {
		Send import to comment.php.
	} else {
		send edit and import.
	}
*/


// Load bootstrap
define ('BOOT', 1);
require ('boot.php');
require ('paintsave.php');

// Input
$xcord = w_gpc('xcord', 'i');
$ycord = w_gpc('ycord', 'i');
$anim  = w_gpc('anim', 'i');
$edit  = w_gpc('edit', 'i+');
$user_pass = ''; // Wacintaki only

// Init
$app_head     = ''; // Passed to save tool
$app_head_pw  = ''; // Added to $app_head
$app_url_exit = ''; // Params for index (comment)
$import       = ''; // Canvas number to import.  Passed to save tool
$app_import   = ''; // Canvas/anim filename to import (based on $anim)
$anim_type    = 'oeb'; // Extension for animation


// Check Draw access
if (!$flags['D']) {
	report_err($langop_err_drawaccess);
}

// Check anim access
// If retouch, anim flag is ignored
if (!$flags['M']) {
	$anim = 0;
}


if ($edit) {
	// Get pic info
	$result = db_query ("SELECT PIC_ID, usrname, animation, ptype FROM {$db_p}oekakidta WHERE PIC_ID='$edit'");
	$row = db_fetch_array ($result);

	// Verify anim
	if ($row['animation'] == 1) {
		$anim = 1;
	} else {
		$anim = 0;
	}

	// Set up import (edit only)
	if ($anim) {
		$app_import = $p_pic.$edit.'.'.$anim_type;
	} else {
		$app_import = $p_pic.$edit.'.'.$row['ptype'];
	}

	$size = @GetImageSize ($p_pic.$row['PIC_ID'].'.'.$row['ptype']);
	$xcord = $size[0];
	$ycord = $size[1];
}


// Verify that canvas sizes fit min/max
$xcord = fix_range($cfg['min_x'], $cfg['canvas_x'], $xcord);
$ycord = fix_range($cfg['min_y'], $cfg['canvas_y'], $ycord);


// Bug in Mac version of Java requires hard-coded values, rather than CSS.  >:(
// Typical viewable width of 800x600 browser is 740px.
	$xhack = '740';
// Typical height
	$yhack = '550';


// APPLET_NO_JPEG is in hacks.php
// Due to lack of documentation, I don't know how to set max size of JPEG (or even if it's possible)
$image_jpeg_value = (APPLET_NO_JPEG != 0) ? '0' : '1';


// Set up applet header
// NOTE:  It is illegal to use '&' in parameter fields of Java applets,
// but we have to do it anyway since OekakiBBS will not decode '&amp;'
if ($edit) {
	$app_head_mode = 'edit';
} elseif ($anim) {
	$app_head_mode = 'anim';
} else {
	$app_head_mode = 'norm';
}

$app_head = "mode={$app_head_mode}&edittimes=".time()
	.'&usr='.urlencode ($OekakiU).'&vcode='.urlencode ($OekakiPass);
if ($edit) {
	$app_head .= "&edit={$edit}";
}

// Set up applet exit
$app_url_exit = 'comment.php?mode=res_msg';
if ($edit) {
	$app_url_exit .= "&edit={$edit}";
}

// Wax Poteto fans seem to prefer the header
$no_banner = TRUE;
if (w_gpc('noclose')) {
	$header_extra_script = "\t<script type=\"text/javascript\">\n\t\tnoBadClose();\n\t</script>\n";
}
require ('header.php');


?>
<div align="center">
	<applet id="oekakibbs"
		code="a.p.class"
		archive="oekakibbs.jar"
		width="<?php echo $xhack;?>"
		height="<?php echo $yhack;?>">

		<!-- Disable Java DirectX support -->
		<param name="java_arguments" value="-Dsun.java2d.noddraw=true" />
		<param name="java_arguments" value="-Dsun.java2d.d3d=false" />

		<param name="picw" value="<?php echo $xcord;?>" />
		<param name="pich" value="<?php echo $ycord;?>" />

		<param name="tooljpgpng" value="0" />
		<param name="tooljpg" value="<?php echo $image_jpeg_value;?>" />

		<param name="anime" value="<?php echo $anim;?>" />
		<param name="animesimple" value="1" />

<?php
if ($edit) { ?>
		<param name="readfilepath" value="./" />
		<param name="readpicpath" value="./" />
		<param name="readpic" value="<?php echo $p_pic.$edit.'.'.$row['ptype']; ?>" />

<?php
	if ($anim) { ?>
		<param name="readanmpath" value="./" />
		<param name="readanm" value="<?php echo $p_pic.$edit.'.oeb'; ?>" />

<?php
	}
}
?>
		<param name="cgi" value="getoekakibbs.php?<?php echo w_html_chars($app_head);?>" />
		<param name="url" value="<?php echo w_html_chars($app_url_exit);?>" />
		<param name="target" value="_self" />

		<param name="popup" value="0" />
		<param name="tooltype" value="full" />
		<param name="passwd" value="hardidhihihiahrih" />
		<param name="passwd2" value="I like to eat, ice cream." />

		<param name="baseC" value="888888" />
		<param name="brightC" value="aaaaaa" />
		<param name="darkC" value="666666" />
		<param name="backC" value="000000" />

		<param name="mask" value="5" />
		<param name="toolpaintmode" value="1" />
		<param name="toolmask" value="1" />
		<param name="toollayer" value="1" />
		<param name="toolalpha" value="1" />
		<param name="toolwidth" value="200" />

		<param name="catalog" value="0" />
		<param name="catalogwidth" value="100" />
		<param name="catalogheight" value="100" />

		You need Java&trade; to run this applet.  <a href="http://www.java.com">Click here to download Java</a>.
	</applet>
</div>


<p style="text-align: center;">
	<input onclick="maximize_app('oekakibbs')" type="button" value="<?php echo $langop_resizeapplet;?>" class="submit" />
</p>


<p style="text-align: center;">
	<input onclick="size_app('oekakibbs');" type="button" value="<?php echo $langop_resize_to_this;?>" class="submit" />
	X:<input id="button_x" type="text" size="3" value="<?php echo $xhack;?>" class="txtinput" />
	Y:<input id="button_y" type="text" size="3" value="<?php echo $yhack;?>" class="txtinput" />
</p>


<?php if (!$edit) { ?>
<form name="formResize" method="get" action="<?php echo $_SERVER['PHP_SELF'];?>">
	<table width="50%" border="0" cellspacing="0" cellpadding="2" align="center" class="infotable">
	<tr>
	<td colspan="2" height="11">
		<table width="<?php echo $hWidth;?>" cellpadding="<?php echo $hCellPadding;?>" align="center" class="header">
		<tr>
		<td align="center">
			<font size="-2">
				<?php echo $langop_applet_modify;?> 
				(<?php echo $langop_applet_max;?> <?php echo $cfg['canvas_x'];?> &times; <?php echo $cfg['canvas_y'];?> )
			</font>
		</td>
		</tr>
		</table>
	</td>
	</tr>

	<tr>
	<td width="28%">
		<div align="right">
			<font size="-2">X</font>:
		</div>
	</td>
	<td width="72%">
		<font size="-2">
			<input type="text" name="xcord" value="<?php echo $xcord;?>" class="txtinput" />
		</font>
	</td>
	</tr>

	<tr>
	<td width="28%">
		<div align="right">
			<font size="-2">Y:</font>
		</div>
	</td>
	<td width="72%">
		<font size="-2">
			<input type="text" name="ycord" value="<?php echo $ycord;?>" class="txtinput" />
		</font>
	</td>
	</tr>

	<tr>
	<td></td>
	<td>
		<font size="-2">
			<input type="submit" name="Submit" value="<?php echo $langop_word_modify;?>" class="submit" />
		</font>
	</td>
	</tr>
	</table>

<?php if ($edit) { ?>
	<input type="hidden" name="edit" value="<?php echo $edit;?>" />
<?php } ?>
<?php if ($anim) { ?>
	<input type="hidden" name="anim" value="<?php echo $anim;?>" />
<?php } ?>
<?php if (w_gpc('noclose')) { ?>
	<input type="hidden" name="noclose" value="1" />
<?php } ?>
</form>
<?php } ?>
<br />

<?php include ('footer.php'); ?>