<?php
/*
Animation code by Marcello (http://www.cellosoft.com). Modified by RanmaGuy. Used with permission. This file is not to be used with any other script other than OekakiPoteto.

Wax Poteto modifications Copyright Marc "Waccoon" Leveille
http://www.NineChime.com/products/
Version 5.8.2 - Last modified 12/26/2010
*/


/*
NOTES:

Cookies don't [aren't supposed to] work with POST, so we get $OekakiU from applet and load boot.php later.  All variables end up in keyed array $params.  We process that first before adding the bootstrap.  Note that everything comes from CGI, so addslashes() as needed!

Special error reporting is needed, because errors are return codes sent to the applet, not the web browser.
*/


// Error reporting
function print_ok() {
	global $dbconn;
	if (!empty ($dbconn)) {
		db_close();
	}

	header('Content-type: text/plain');
	exit ('ok');
}
function quiet_exit($exit_err) {
	global $dbconn;
	if (!empty ($dbconn)) {
		db_close();
	}

	header ('Content-type: text/plain');
	echo "error\n";
	exit ($exit_err);
}


// Get raw POST data
if (empty ($HTTP_RAW_POST_DATA)) {
	$raw_buffer = file_get_contents ('php://input');
} else {
	$raw_buffer =& $HTTP_RAW_POST_DATA;
}


// Parse input for login
$OekakiU    = '';
$OekakiPass = '';
if (substr ($raw_buffer, 0, 1) == 'P') {
	// Header
	$image['h_length'] = substr ($raw_buffer, 1, 8);
	$image['h_length'] = (int) $image['h_length'];
	$image['h_data']   = substr ($raw_buffer, 9, $image['h_length']);

	$params = array ();
	$pairs = explode(';', $image['h_data']);
	for ($i = count ($pairs); --$i >= 0;) {
		$keyvals = explode ('=', $pairs[$i]);
		$params[$keyvals[0]] = $keyvals[1];
	}

	// Login is sent in the parameters, and is UTF-8 encoded
	$OekakiU    = addslashes (utf8_decode ($params['usr']));
	$OekakiPass = addslashes ($params['vcode']);
} else {
	// Failure, but try to get the cookie so we can log stuff properly.
	$params['usr'] = NULL;
	if (isset($_REQUEST['OekakiU']) && isset($_REQUEST['OekakiPass'])) {
		$OekakiU    = $_REQUEST['OekakiU'];
		$OekakiPass = $_REQUEST['OekakiPass'];
	}
}


// Load bootstrap, quiet mode
if (empty ($OekakiU)) {
	// English only
	quiet_exit('Login could not be verified!  Take a screenshot of your picture.');
}
$quiet_mode = TRUE;
$no_online = TRUE;
define ('BOOT', 1);
require ('boot.php');
require ('paintsave.php');


// Clean input
$mode      = $params['mode'];
$edittimes = (int) $params['edittimes'];
$edit      = (int) $params['edit'];
$import    = (int) $params['import'];
$user_pass = ''; // Wacintaki only


// Test input
if (empty ($raw_buffer)) {
	// No data to save!
	w_log(WLOG_SECURITY, 'paintbbsget: no RAW POST data');
	quiet_exit($langop_err_nodata);
}
if (substr ($raw_buffer, 0, 1) != 'P') {
	quiet_exit($langop_poo_compat." '<param name=\"poo\" value=\"false\" />'");
}


// PaintBBS data
if (substr ($raw_buffer, 0, 1) == 'P') {
	// Image data
	$image['o_length'] = substr ($raw_buffer, $image['h_length'] + 9, 8);
	$image['o_length'] = (int) $image['o_length'];
	$image['o_data']   = substr ($raw_buffer, $image['h_length'] + 19, $image['o_length']);

	// Animation
	$image['t_length'] = substr ($raw_buffer, $image['h_length'] + $image['o_length'] + 19, 8);
	$image['t_length'] = (int) $image['t_length'];
	$image['t_data']   = substr ($raw_buffer, $image['h_length'] + $image['o_length'] + 27, $image['t_length']);

	// Thumbnail
	$image['t2_length'] = substr ($raw_buffer, $image['h_length'] + $image['o_length'] + $image['t_length'] + 27, 8);
	$image['t2_length'] = (int) $image['t2_length'];
	$image['t2_data']   = substr ($raw_buffer, $image['h_length'] + $image['o_length'] + $image['t_length'] + 35, $image['t2_length']);
}

// Check image
if (empty ($image['o_data'])) {
	quiet_exit($langop_err_nodata);
}
// Is animation too big?
if ($image['t_length'] > $cfg['max_anim']) {
	$image['t_length'] = 0;
	$image['t_data'] = NULL;
}


// Insert new slot into database
if ($mode == 'norm' || $mode == 'anim') {
	$resno = get_new_picnumber();
	if ($resno == 0) {
		w_log(WLOG_FAIL, 'paintbbsget: cannot allocate new PIC_ID');
		quiet_exit($langop_err_picts);
	}

	// Cleanup slots
	$result = clean_picture_slots();

	$thetime = time() - $edittimes;

	// Insert new slot
	$tries = 5;
	while ($tries > 0) {
		$sqlres = "INSERT INTO {$db_p}oekakidta SET usrname='$OekakiU', postdate=NOW(), hostname='$hostname', comment='', PIC_ID='$resno', IP='$address', datatype=0, edittime='$thetime', password=''";
		if ($mode == 'anim') {
			$sqlres .= ', animation=1';
		} else {
			$sqlres .= ', animation=0';
		}
		$result = db_query ($sqlres);

		if ($result) {
			$tries = 0;
		} else {
			$tries--;
			sleep (1);
		}
	}
	if (!$result) {
		w_log_sql('paintbbsget: cannot save image '.$resno);
		quiet_exit($langop_err_saveimg);
	}
}


// Update edited slot to database
if ($mode == 'edit') {
	// Verify edit, otherwise invalidate it
	$resno = verify_edit($edit, $user_pass);

	$edittime2 = time() - $edittimes;
	$result2 = db_query ("UPDATE {$db_p}oekakidta SET edittime=(edittime + $edittime2) WHERE PIC_ID='$resno'");
}


// Write files
//
// Save image/anim data.  Filetype is automatic!
if (!save_image($image['o_data'], $resno)) {
	w_log(WLOG_FAIL, 'paintbbsget: cannot save image '.$resno);
	quiet_exit($langop_err_saveimg);
}
if (!empty ($image['t_data'])) {
	save_anim($image['t_data'], $resno, 'pch');
}


print_ok();

?>